   #include <stdio.h>
   #include "SpiceUsr.h"

   int main()
{
   SpiceChar             * mkfile;
   SpiceChar             * utc;
   SpiceChar             * sclk;
   SpiceChar             * target;
   SpiceChar             * frame;
   SpiceChar             * corrtn;
   SpiceChar             * observ;
   SpiceChar             * method;
   SpiceChar             * fromfr;
   SpiceChar             * tofr;

   SpiceDouble             et;
   SpiceDouble             state  [6];
   SpiceDouble             sundir [3];
   SpiceDouble             lt;
   SpiceDouble             spoint [3];
   SpiceDouble             alt;
   SpiceDouble             srad;
   SpiceDouble             slon;
   SpiceDouble             slat;
   SpiceDouble             scpos  [3];
   SpiceDouble             sbpdir [3];
   SpiceDouble             m2imat [3][3];
   SpiceDouble             scvdir [3];
   SpiceDouble             j2imat [3][3];

   SpiceInt                scid;

   SpiceBoolean            gotsat;
   SpiceBoolean            gotaat;
   

   mkfile  =  "spice_example.mk";
   furnsh_c ( mkfile );

   utc     =  "2004-01-11T22:05:24";
   str2et_c ( utc, &et );

   printf ( "utc  = %s     \n", utc );
   printf ( "et   = %20.6f \n", et  );

   scid   = -41;
   sclk   = "21938715:00525";
   scs2e_c ( scid, sclk, &et );

   printf ( "sclk = %s     \n", sclk );
   printf ( "et   = %20.6f \n", et  );

   target = "MEX";
   frame  = "ECLIPJ2000";
   corrtn = "NONE";
   observ = "SUN";

   spkezr_c ( target, et, frame, corrtn, observ, state, &lt );

   printf ( "state = %e %e %e %e %e %e\n", 
            state[0], state[1], state[2], 
            state[3], state[4], state[5] );

   checkck ( et, &gotsat, &gotaat );
   if ( ! gotsat ) 
   {
      printf ( "STOP: s/c orientation not available.\n" );
      return(1);
   }

   target = "SUN";
   frame  = "MEX_SPACECRAFT";
   corrtn = "LT+S";
   observ = "MEX";

   spkpos_c ( target, et, frame, corrtn, observ, sundir, &lt );
   vhat_c   ( sundir, sundir );

   printf ( "sundir = %e %e %e\n", 
            sundir[0], sundir[1], sundir[2] );

   method = "NEAR POINT";
   target = "MARS";
   corrtn = "NONE";
   observ = "MEX";
   
   subpt_c ( method, target, et, corrtn, observ, spoint, &alt );

   reclat_c ( spoint, &srad, &slon, &slat );

   target = "MEX";
   frame  = "IAU_MARS";
   corrtn = "NONE";
   observ = "MARS";

   spkpos_c ( target, et, frame, corrtn, observ, scpos, &lt );

   vsub_c ( spoint, scpos, sbpdir );

   fromfr = "IAU_MARS";
   tofr   = "MEX_SPACECRAFT";
   
   pxform_c ( fromfr, tofr, et, m2imat );

   mxv_c  ( m2imat, sbpdir, sbpdir );
   vhat_c ( sbpdir, sbpdir );

   printf ( "alt    =  %e \n", alt            );
   printf ( "lon    =  %e \n", slon * dpr_c() );
   printf ( "lat    =  %e \n", slat * dpr_c() );
   printf ( "sbpdir =  %e %e %e \n", 
             sbpdir[0], sbpdir[1], sbpdir[2]       );

   target = "MEX";
   frame  = "J2000";
   corrtn = "NONE";
   observ = "MARS";
   
   spkezr_c ( target, et, frame, corrtn, observ, state, &lt );
   vpack_c  ( state[3], state[4], state[5], scvdir );

   fromfr = "J2000";
   tofr   = "MEX_SPACECRAFT";
   pxform_c ( fromfr, tofr, et, j2imat );

   mxv_c  ( j2imat, scvdir, scvdir );
   vhat_c ( scvdir, scvdir );

   printf ( "scvdir = %e %e %e \n", 
            scvdir[0], scvdir[1], scvdir[2] ); 


   return ( 0 );
}
