   #include <stdio.h>
   #include "SpiceUsr.h"

   int main()
{
   SpiceBoolean            gotaat;
   SpiceBoolean            gotsat;

   SpiceChar               secfrm [33];
   SpiceChar               sensnm [33];
   SpiceChar             * corrtn;
   SpiceChar             * frame;
   SpiceChar             * fromfr;
   SpiceChar             * method;
   SpiceChar             * mkfile;
   SpiceChar             * observ;
   SpiceChar             * sclk;
   SpiceChar             * sensor;
   SpiceChar             * target;
   SpiceChar             * tofr;
   SpiceChar             * utc;

   SpiceDouble             a2smat [3][3];
   SpiceDouble             alt;
   SpiceDouble             angle;
   SpiceDouble             et;
   SpiceDouble             hvec [3];
   SpiceDouble             j2imat [3][3];
   SpiceDouble             lt;
   SpiceDouble             m1 [3][3];
   SpiceDouble             m2 [3][3];
   SpiceDouble             m2imat [3][3];
   SpiceDouble             m3 [3][3];
   SpiceDouble             mbase  [3][3];
   SpiceDouble             sbpdir [3];
   SpiceDouble             scpos  [3];
   SpiceDouble             scvdir [3];
   SpiceDouble             secdir [32][3];
   SpiceDouble             secsiz [2];
   SpiceDouble             slat;
   SpiceDouble             slon;
   SpiceDouble             spoint [3];
   SpiceDouble             srad;
   SpiceDouble             state  [6];
   SpiceDouble             sundir [3];

   SpiceInt                i;
   SpiceInt                scid;
   SpiceInt                secnum [2];
   SpiceInt                sensid;

   mkfile  =  "spice_example.mk";
   furnsh_c ( mkfile );

   utc     =  "2004-01-11T22:05:24";
   str2et_c ( utc, &et );

   printf ( "utc  = %s     \n", utc );
   printf ( "et   = %20.6f \n", et  );

   scid   = -41;
   sclk   = "21938715:00525";
   scs2e_c ( scid, sclk, &et );

   printf ( "sclk = %s     \n", sclk );
   printf ( "et   = %20.6f \n", et  );

   target = "MEX";
   frame  = "ECLIPJ2000";
   corrtn = "NONE";
   observ = "SUN";

   spkezr_c ( target, et, frame, corrtn, observ, state, &lt );

   printf ( "state = %e %e %e %e %e %e\n", 
            state[0], state[1], state[2], 
            state[3], state[4], state[5] );

   checkck ( et, &gotsat, &gotaat );
   if ( ! gotsat ) 
   {
      printf ( "STOP: s/c orientation not available.\n" );
      return(1);
   }

   target = "SUN";
   frame  = "MEX_SPACECRAFT";
   corrtn = "LT+S";
   observ = "MEX";

   spkpos_c ( target, et, frame, corrtn, observ, sundir, &lt );
   vhat_c   ( sundir, sundir );

   printf ( "sundir = %e %e %e\n", 
            sundir[0], sundir[1], sundir[2] );

   method = "NEAR POINT";
   target = "MARS";
   corrtn = "NONE";
   observ = "MEX";
   
   subpt_c ( method, target, et, corrtn, observ, spoint, &alt );

   reclat_c ( spoint, &srad, &slon, &slat );

   target = "MEX";
   frame  = "IAU_MARS";
   corrtn = "NONE";
   observ = "MARS";

   spkpos_c ( target, et, frame, corrtn, observ, scpos, &lt );

   vsub_c ( spoint, scpos, sbpdir );

   fromfr = "IAU_MARS";
   tofr   = "MEX_SPACECRAFT";
   
   pxform_c ( fromfr, tofr, et, m2imat );

   mxv_c  ( m2imat, sbpdir, sbpdir );
   vhat_c ( sbpdir, sbpdir );

   printf ( "alt    =  %e \n", alt            );
   printf ( "lon    =  %e \n", slon * dpr_c() );
   printf ( "lat    =  %e \n", slat * dpr_c() );
   printf ( "sbpdir =  %e %e %e \n", 
             sbpdir[0], sbpdir[1], sbpdir[2]       );

   target = "MEX";
   frame  = "J2000";
   corrtn = "NONE";
   observ = "MARS";
   
   spkezr_c ( target, et, frame, corrtn, observ, state, &lt );
   vpack_c  ( state[3], state[4], state[5], scvdir );

   fromfr = "J2000";
   tofr   = "MEX_SPACECRAFT";
   pxform_c ( fromfr, tofr, et, j2imat );

   mxv_c  ( j2imat, scvdir, scvdir );
   vhat_c ( scvdir, scvdir );

   printf ( "scvdir = %e %e %e \n", 
            scvdir[0], scvdir[1], scvdir[2] ); 

   sensor = "ELS";
   getik( sensor, sensnm, &sensid, secnum, secsiz, secfrm, 
         ( SpiceDouble * ) secdir );

   angle = 45.0;
   pxform_c ( secfrm,            "MEX_ASPERA_SCANNER", et, m1 );
   rotate_c ( -(angle+180.0)/dpr_c(),                   3, m2 );
   pxform_c ( "MEX_ASPERA_BASE", "MEX_SPACECRAFT",     et, m3 );

   mxm_c    ( m2, m1,    mbase  );
   mxm_c    ( m3, mbase, a2smat );

   for ( i = 0; i < secnum[0]; i++ )
   {
      mxv_c ( a2smat, secdir[i], hvec );
      printf( "SECTOR %i: %12.9f %12.9f %12.9f\n", 
            i+1, hvec[0], hvec[1], hvec[2] );
   }


   return ( 0 );
}
