      IMPLICIT NONE

      CHARACTER*(256)      MKFILE
      CHARACTER*(32)       UTC
      CHARACTER*(32)       SCLK
      CHARACTER*(32)       TARGET
      CHARACTER*(32)       FRAME
      CHARACTER*(32)       CORRTN
      CHARACTER*(32)       OBSERV
      DOUBLE PRECISION     ET
      DOUBLE PRECISION     STATE  ( 6 )
      DOUBLE PRECISION     SUNDIR ( 3 )
      DOUBLE PRECISION     LT
      INTEGER              SCID
      LOGICAL              GOTSAT
      LOGICAL              GOTAAT

      MKFILE = 'spice_example.mk'
      CALL FURNSH( MKFILE )

      UTC = '2004-01-11T22:05:24'
      CALL STR2ET( UTC, ET )

      WRITE(*,*) 'UTC  = ', UTC
      WRITE(*,*) 'ET   = ', ET

      SCID = -41
      SCLK = '21938715:00525'
      CALL SCS2E( SCID, SCLK, ET )

      WRITE(*,*) 'SCLK = ', SCLK
      WRITE(*,*) 'ET   = ', ET

      TARGET = 'MEX'
      FRAME  = 'ECLIPJ2000'
      CORRTN = 'NONE'
      OBSERV = 'SUN'
      CALL SPKEZR( TARGET, ET, FRAME, CORRTN, OBSERV, STATE, LT )
      WRITE(*,*) 'STATE = ', STATE

      CALL CHECKCK ( ET, GOTSAT, GOTAAT )
      IF ( .NOT. GOTSAT ) THEN
         WRITE (*,*) 'STOP: s/c orientation not available.'
         STOP
      END IF

      TARGET = 'SUN'
      FRAME  = 'MEX_SPACECRAFT'
      CORRTN = 'LT+S'
      OBSERV = 'MEX'
      CALL SPKPOS( TARGET, ET, FRAME, CORRTN, OBSERV, SUNDIR, LT )
      CALL VHAT  ( SUNDIR, SUNDIR )
      WRITE(*,*) 'SUNDIR = ', SUNDIR
      END
