      IMPLICIT NONE

      CHARACTER*(256)      MKFILE
      CHARACTER*(32)       UTC
      CHARACTER*(32)       SCLK
      CHARACTER*(32)       TARGET
      CHARACTER*(32)       FRAME
      CHARACTER*(32)       CORRTN
      CHARACTER*(32)       OBSERV
      CHARACTER*(32)       METHOD
      CHARACTER*(32)       FROMFR
      CHARACTER*(32)       TOFR
      DOUBLE PRECISION     ET
      DOUBLE PRECISION     STATE  ( 6 )
      DOUBLE PRECISION     SUNDIR ( 3 )
      DOUBLE PRECISION     LT
      DOUBLE PRECISION     SPOINT ( 3 )
      DOUBLE PRECISION     ALT
      DOUBLE PRECISION     SRAD
      DOUBLE PRECISION     SLON
      DOUBLE PRECISION     SLAT
      DOUBLE PRECISION     SCPOS  ( 3 )
      DOUBLE PRECISION     SBPDIR ( 3 )
      DOUBLE PRECISION     M2IMAT ( 3, 3 )
      DOUBLE PRECISION     SCVDIR ( 3 )
      DOUBLE PRECISION     J2IMAT ( 3, 3 )
      INTEGER              SCID
      LOGICAL              GOTSAT
      LOGICAL              GOTAAT

      DOUBLE PRECISION     DPR


      MKFILE = 'spice_example.mk'
      CALL FURNSH( MKFILE )

      UTC = '2004-01-11T22:05:24'
      CALL STR2ET( UTC, ET )

      WRITE(*,*) 'UTC  = ', UTC
      WRITE(*,*) 'ET   = ', ET

      SCID = -41
      SCLK = '21938715:00525'
      CALL SCS2E( SCID, SCLK, ET )

      WRITE(*,*) 'SCLK = ', SCLK
      WRITE(*,*) 'ET   = ', ET

      TARGET = 'MEX'
      FRAME  = 'ECLIPJ2000'
      CORRTN = 'NONE'
      OBSERV = 'SUN'
      CALL SPKEZR( TARGET, ET, FRAME, CORRTN, OBSERV, STATE, LT )
      WRITE(*,*) 'STATE = ', STATE

      CALL CHECKCK ( ET, GOTSAT, GOTAAT )
      IF ( .NOT. GOTSAT ) THEN
         WRITE (*,*) 'STOP: s/c orientation not available.'
         STOP
      END IF

      TARGET = 'SUN'
      FRAME  = 'MEX_SPACECRAFT'
      CORRTN = 'LT+S'
      OBSERV = 'MEX'
      CALL SPKPOS( TARGET, ET, FRAME, CORRTN, OBSERV, SUNDIR, LT )
      CALL VHAT  ( SUNDIR, SUNDIR )
      WRITE(*,*) 'SUNDIR = ', SUNDIR

      METHOD = 'NEAR POINT'
      TARGET = 'MARS'
      CORRTN = 'NONE'
      OBSERV = 'MEX'
      CALL SUBPT ( METHOD, TARGET, ET, CORRTN, OBSERV, SPOINT, ALT )

      CALL RECLAT( SPOINT, SRAD, SLON, SLAT )

      TARGET = 'MEX'
      FRAME  = 'IAU_MARS'
      CORRTN = 'NONE'
      OBSERV = 'MARS'
      CALL SPKPOS( TARGET, ET, FRAME, CORRTN, OBSERV, SCPOS, LT )

      CALL VSUB  ( SPOINT, SCPOS, SBPDIR )

      FROMFR = 'IAU_MARS'
      TOFR   = 'MEX_SPACECRAFT'
      CALL PXFORM( FROMFR, TOFR, ET, M2IMAT )

      CALL MXV   ( M2IMAT, SBPDIR, SBPDIR )
      CALL VHAT  ( SBPDIR, SBPDIR )

      WRITE(*,*) 'ALT = ', ALT
      WRITE(*,*) 'LON = ', SLON*DPR()
      WRITE(*,*) 'LAT = ', SLAT*DPR()
      WRITE(*,*) 'SBPDIR = ', SBPDIR

      TARGET = 'MEX'
      FRAME  = 'J2000'
      CORRTN = 'NONE'
      OBSERV = 'MARS'
      CALL SPKEZR( TARGET, ET, FRAME, CORRTN, OBSERV, STATE, LT )
      CALL VPACK ( STATE(4), STATE(5), STATE(6), SCVDIR )

      FROMFR = 'J2000'
      TOFR   = 'MEX_SPACECRAFT'
      CALL PXFORM( FROMFR, TOFR, ET, J2IMAT )

      CALL MXV   ( J2IMAT, SCVDIR, SCVDIR )
      CALL VHAT  ( SCVDIR, SCVDIR )

      WRITE(*,*) 'SCVDIR = ', SCVDIR

      END
