      IMPLICIT NONE

      CHARACTER*(256)      MKFILE
      CHARACTER*(32)       CORRTN
      CHARACTER*(32)       FRAME
      CHARACTER*(32)       FROMFR
      CHARACTER*(32)       METHOD
      CHARACTER*(32)       OBSERV
      CHARACTER*(32)       SCLK
      CHARACTER*(32)       SECFRM
      CHARACTER*(32)       SENSNM
      CHARACTER*(32)       SENSOR
      CHARACTER*(32)       TARGET
      CHARACTER*(32)       TOFR
      CHARACTER*(32)       UTC
      DOUBLE PRECISION     A2SMAT ( 3, 3 )
      DOUBLE PRECISION     ALT
      DOUBLE PRECISION     ANGLE
      DOUBLE PRECISION     ET
      DOUBLE PRECISION     HVEC   ( 3 )
      DOUBLE PRECISION     J2IMAT ( 3, 3 )
      DOUBLE PRECISION     LT
      DOUBLE PRECISION     M1     ( 3, 3 )
      DOUBLE PRECISION     M2     ( 3, 3 )
      DOUBLE PRECISION     M2IMAT ( 3, 3 )
      DOUBLE PRECISION     M3     ( 3, 3 )
      DOUBLE PRECISION     MBASE  ( 3, 3 )
      DOUBLE PRECISION     SBPDIR ( 3 )
      DOUBLE PRECISION     SCPOS  ( 3 )
      DOUBLE PRECISION     SCVDIR ( 3 )
      DOUBLE PRECISION     SECDIR ( 3, 32 )
      DOUBLE PRECISION     SECSIZ ( 2 )
      DOUBLE PRECISION     SLAT
      DOUBLE PRECISION     SLON
      DOUBLE PRECISION     SPOINT ( 3 )
      DOUBLE PRECISION     SRAD
      DOUBLE PRECISION     STATE  ( 6 )
      DOUBLE PRECISION     SUNDIR ( 3 )
      INTEGER              I
      INTEGER              SCID
      INTEGER              SECNUM ( 2 )
      INTEGER              SENSID
      LOGICAL              GOTAAT
      LOGICAL              GOTSAT

      DOUBLE PRECISION     DPR
      DOUBLE PRECISION     RPD

      MKFILE = 'spice_example.mk'
      CALL FURNSH( MKFILE )

      UTC = '2004-01-11T22:05:24'
      CALL STR2ET( UTC, ET )

      WRITE(*,*) 'UTC  = ', UTC
      WRITE(*,*) 'ET   = ', ET

      SCID = -41
      SCLK = '21938715:00525'
      CALL SCS2E( SCID, SCLK, ET )

      WRITE(*,*) 'SCLK = ', SCLK
      WRITE(*,*) 'ET   = ', ET

      TARGET = 'MEX'
      FRAME  = 'ECLIPJ2000'
      CORRTN = 'NONE'
      OBSERV = 'SUN'
      CALL SPKEZR( TARGET, ET, FRAME, CORRTN, OBSERV, STATE, LT )
      WRITE(*,*) 'STATE = ', STATE

      CALL CHECKCK ( ET, GOTSAT, GOTAAT )
      IF ( .NOT. GOTSAT ) THEN
         WRITE (*,*) 'STOP: s/c orientation not available.'
         STOP
      END IF

      TARGET = 'SUN'
      FRAME  = 'MEX_SPACECRAFT'
      CORRTN = 'LT+S'
      OBSERV = 'MEX'
      CALL SPKPOS( TARGET, ET, FRAME, CORRTN, OBSERV, SUNDIR, LT )
      CALL VHAT  ( SUNDIR, SUNDIR )
      WRITE(*,*) 'SUNDIR = ', SUNDIR

      METHOD = 'NEAR POINT'
      TARGET = 'MARS'
      CORRTN = 'NONE'
      OBSERV = 'MEX'
      CALL SUBPT ( METHOD, TARGET, ET, CORRTN, OBSERV, SPOINT, ALT )

      CALL RECLAT( SPOINT, SRAD, SLON, SLAT )

      TARGET = 'MEX'
      FRAME  = 'IAU_MARS'
      CORRTN = 'NONE'
      OBSERV = 'MARS'
      CALL SPKPOS( TARGET, ET, FRAME, CORRTN, OBSERV, SCPOS, LT )

      CALL VSUB  ( SPOINT, SCPOS, SBPDIR )

      FROMFR = 'IAU_MARS'
      TOFR   = 'MEX_SPACECRAFT'
      CALL PXFORM( FROMFR, TOFR, ET, M2IMAT )

      CALL MXV   ( M2IMAT, SBPDIR, SBPDIR )
      CALL VHAT  ( SBPDIR, SBPDIR )

      WRITE(*,*) 'ALT = ', ALT
      WRITE(*,*) 'LON = ', SLON*DPR()
      WRITE(*,*) 'LAT = ', SLAT*DPR()
      WRITE(*,*) 'SBPDIR = ', SBPDIR

      TARGET = 'MEX'
      FRAME  = 'J2000'
      CORRTN = 'NONE'
      OBSERV = 'MARS'
      CALL SPKEZR( TARGET, ET, FRAME, CORRTN, OBSERV, STATE, LT )
      CALL VPACK ( STATE(4), STATE(5), STATE(6), SCVDIR )

      FROMFR = 'J2000'
      TOFR   = 'MEX_SPACECRAFT'
      CALL PXFORM( FROMFR, TOFR, ET, J2IMAT )

      CALL MXV   ( J2IMAT, SCVDIR, SCVDIR )
      CALL VHAT  ( SCVDIR, SCVDIR )

      WRITE(*,*) 'SCVDIR = ', SCVDIR

      SENSOR = 'ELS'
      CALL GETIK  ( SENSOR, SENSNM, SENSID, 
     .              SECNUM, SECSIZ, SECFRM, SECDIR )

      ANGLE = 45.0D0
      CALL PXFORM ( SECFRM, 'MEX_ASPERA_SCANNER',        ET, M1 )
      CALL ROTATE ( -(ANGLE+180.D0) * RPD(),             3,  M2 )
      CALL PXFORM ( 'MEX_ASPERA_BASE', 'MEX_SPACECRAFT', ET, M3 )

      CALL MXM    ( M2, M1,    MBASE  )
      CALL MXM    ( M3, MBASE, A2SMAT )

      DO I = 1, SECNUM(1)
         CALL MXV ( A2SMAT, SECDIR(1,I), HVEC )
         WRITE ( *, * ) 'SECTOR', I, ':', HVEC
      END DO

      END
